'''
Created on Aug 26, 2010

@author: donal
'''
from cocos.cocosnode import CocosNode
from cocos.actions import *
from cocos.euclid import Point2, Vector2
from vector import *
from math import *

def sprite_intersect(sp1, sp2):
    #http://www.gamedev.net/reference/articles/article735.asp
    # oops todo is to us cocos internal... oh well
    reduction = 0.9
    # first rect
    x1, y1 = sp1.position
    rh1 = sp1.height * reduction
    rw1 = sp1.width * (reduction - .3)
    top1 = round(y1 + rh1)
    bottom1 = round(y1)
    left1 = round(x1 + (rw1 / 2))
    right1 = round(x1 - (rw1 / 2))
    # second rect
    x2, y2 = sp2.position
    rh2 = sp2.height * reduction
    rw2 = sp2.width * reduction
    top2 = round(y2 + rh2)
    bottom2 = round(y2)
    left2 = round(x2 + (rw2 / 2))
    right2 = round(x2 - (rw2 / 2))
    
    if (bottom1 > top2): return False;
    if (top1 < bottom2): return False;
    if (right1 > left2): return False;
    if (left1 < right2): return False;
    
    print (top1, left1, right1, bottom1), (top2, left2, right2, bottom2), (bottom1 < top2, top1 > bottom2, right1 < left2, left1 > right2)
    return True
    
class PlayerMove(MoveTo):
    speed = 250
    effective_radius = 0
    destination = (0, 0)
    collided = False
    
    def __init__(self, target_position, time):
        self.destination = target_position
        #print self.__dict__
        super(PlayerMove, self).__init__(self.destination, time)
        
    def update(self, t):

        if (self.target == None): 
            print 'target is none', t
            return True
        if (self.target.state != 'walking'):
            self.target.changeState('walking')

        if not self.collided:
            
            for obj in self.target.parent.stage_objects:
                if (sprite_intersect(self.target, obj)):
                    self.collided = True
                    print 'collided with', obj
                    break
                    
            if (self.collided):
                if (self.destination != self.target.position):
                    if len(self.target.parent.action_queue) > 0 :
                        print self.target.parent.action_queue[0].__class__.__name__
                    else:
                        print 'nothing in queue'
                    self.target.parent.action_queue.append(PlayerDelay(0.1))
                    
                    time = distv(self.target.position, self.destination) / self.speed
                    self.target.parent.action_queue.append(PlayerMove(self.destination, time))

                parent = self.target.parent
                self.target.stop()
                parent.act()
            else:
                super(PlayerMove, self).update(t)

class PlayerJump(JumpBy):
    def update(self, t):
        if (self.target.state != 'jumping'):
            self.target.changeState('jumping')
        super(PlayerJump, self).update(t)

class PlayerDelay(Delay):
    def update(self, t):
        if (self.target.state != 'standing'):
            self.target.changeState('standing')
        super(PlayerDelay, self).update(t)
